package com.hai.dao;

import com.hai.entity.HighActivityPartakeRule;
import com.hai.entity.HighActivityPartakeRuleExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighActivityPartakeRuleMapper extends HighActivityPartakeRuleMapperExt {
    @SelectProvider(type=HighActivityPartakeRuleSqlProvider.class, method="countByExample")
    long countByExample(HighActivityPartakeRuleExample example);

    @DeleteProvider(type=HighActivityPartakeRuleSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighActivityPartakeRuleExample example);

    @Delete({
        "delete from high_activity_partake_rule",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_activity_partake_rule (activity_info_id, partake_mode, ",
        "product_type, product_id, ",
        "product_name, `status`, ",
        "create_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{activityInfoId,jdbcType=BIGINT}, #{partakeMode,jdbcType=INTEGER}, ",
        "#{productType,jdbcType=INTEGER}, #{productId,jdbcType=BIGINT}, ",
        "#{productName,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighActivityPartakeRule record);

    @InsertProvider(type=HighActivityPartakeRuleSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighActivityPartakeRule record);

    @SelectProvider(type=HighActivityPartakeRuleSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="activity_info_id", property="activityInfoId", jdbcType=JdbcType.BIGINT),
        @Result(column="partake_mode", property="partakeMode", jdbcType=JdbcType.INTEGER),
        @Result(column="product_type", property="productType", jdbcType=JdbcType.INTEGER),
        @Result(column="product_id", property="productId", jdbcType=JdbcType.BIGINT),
        @Result(column="product_name", property="productName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighActivityPartakeRule> selectByExample(HighActivityPartakeRuleExample example);

    @Select({
        "select",
        "id, activity_info_id, partake_mode, product_type, product_id, product_name, ",
        "`status`, create_time, ext_1, ext_2, ext_3",
        "from high_activity_partake_rule",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="activity_info_id", property="activityInfoId", jdbcType=JdbcType.BIGINT),
        @Result(column="partake_mode", property="partakeMode", jdbcType=JdbcType.INTEGER),
        @Result(column="product_type", property="productType", jdbcType=JdbcType.INTEGER),
        @Result(column="product_id", property="productId", jdbcType=JdbcType.BIGINT),
        @Result(column="product_name", property="productName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighActivityPartakeRule selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighActivityPartakeRuleSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighActivityPartakeRule record, @Param("example") HighActivityPartakeRuleExample example);

    @UpdateProvider(type=HighActivityPartakeRuleSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighActivityPartakeRule record, @Param("example") HighActivityPartakeRuleExample example);

    @UpdateProvider(type=HighActivityPartakeRuleSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighActivityPartakeRule record);

    @Update({
        "update high_activity_partake_rule",
        "set activity_info_id = #{activityInfoId,jdbcType=BIGINT},",
          "partake_mode = #{partakeMode,jdbcType=INTEGER},",
          "product_type = #{productType,jdbcType=INTEGER},",
          "product_id = #{productId,jdbcType=BIGINT},",
          "product_name = #{productName,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighActivityPartakeRule record);
}