package com.hai.dao;

import com.hai.entity.OutRechargePrice;
import com.hai.entity.OutRechargePriceExample;
import com.hai.entity.SecPermission;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.type.JdbcType;

import java.util.List;
import java.util.Map;

/**
 * mapper扩展类
 */
public interface OutRechargePriceMapperExt {

    @Select({"<script>" +
            "SELECT * from out_recharge_price orp " +
            "join bs_product_platform bpp on orp.id = bpp.source_id " +
            "where status in (1,2) and platform_id = #{param.platformId} " +
            "and operator_type = #{param.operatorType} " +
            "and company_id = #{param.companyId} " +
            "and product_type = 9 " +
            "order by sort asc; " +
            " </script>"})
    @Results({
            @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
            @Result(column="discount", property="discount", jdbcType=JdbcType.DECIMAL),
            @Result(column="operator_type", property="operatorType", jdbcType=JdbcType.INTEGER),
            @Result(column="recharge_ platform", property="rechargePlatform", jdbcType=JdbcType.VARCHAR),
            @Result(column="recharge_type", property="rechargeType", jdbcType=JdbcType.INTEGER),
            @Result(column="recharge_way", property="rechargeWay", jdbcType=JdbcType.INTEGER),
            @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
            @Result(column="sort", property="sort", jdbcType=JdbcType.INTEGER),
            @Result(column="recharge_price", property="rechargePrice", jdbcType=JdbcType.DECIMAL),
            @Result(column="pay_price", property="payPrice", jdbcType=JdbcType.DECIMAL),
            @Result(column="goods_id", property="goodsId", jdbcType=JdbcType.BIGINT),
            @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
            @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
            @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
            @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
            @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
            @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<OutRechargePrice> getUserByPrice(@Param("param") Map<String, Object> param);

}
