package com.hai.service;

import com.hai.entity.BsProductDiscount;
import com.hai.entity.BsProductPayType;
import com.hai.entity.BsProductPlatform;

import java.util.Map;

/**
 * @author Sum1Dream
 * @version 1.0.0
 * @serviceName BsProductDiscountService.java
 * @Description // 查询配置参数
 * @createTime 14:14 2022/5/23
 **/
public interface BsConfigService {

    /**
     * @return com.hai.entity.BsProductDiscount
     * @Author Sum1Dream
     * @name getProductDiscountByMap.java
     * @Description // 查询积分配置
     * @Date 14:16 2022/5/23
     * @Param [java.util.Map<java.lang.String, java.lang.Object>]
     */
    BsProductDiscount getProductDiscountByMap(Map<String, Object> map);

    /**
     * @return com.hai.entity.BsProductPlatform
     * @Author Sum1Dream
     * @name getProductPlatformByMap.java
     * @Description // 查询展示平台
     * @Date 14:18 2022/5/23
     * @Param [java.util.Map<java.lang.String, java.lang.Object>]
     */
    String getProductPlatformByMap(Map<String, Object> map);

    /**
    * @Author Sum1Dream
    * @name geProductPayTypeByMap.java
    * @Description // 查询支付方式
    * @Date 14:20 2022/5/23
    * @Param [java.util.Map<java.lang.String,java.lang.Object>]
    * @return java.lang.String
    */
    String getProductPayTypeByMap(Map<String, Object> map);

}
